USE TESTDB;

#DELETE SINGLE RECORD
DELETE FROM DEPT_LOCATIONS WHERE LOCATION_ID=7;

#DELETE MULTIPLE RECORDS WITH WHERE CLAUSE
DELETE FROM EMPLOYEES2 WHERE EMAIL IS NULL;

#DELETE A TABLE COLUMNS AS FOREIGN KEYS – ERROR 
DELETE FROM EMPLOYEES WHERE EMP_ID = 23;

#DELETE WITH LIMIT ROWS
DELETE FROM EMPLOYEE_DEPT 
WHERE DEPT_ID=2 
LIMIT 3;

#DELETE WITH LIMIT ROWS AND ORDER BY
DELETE FROM EMPLOYEE_DEPT 
WHERE DEPT_ID=2 
ORDER BY RECORD_ID DESC
LIMIT 4;

#DELETE RECORDS FROM ALL TABLES USING MULTIPLE TABLES JOINS
#INNER JOIN
#SELECT QUERY FOR FETCHING RECORDS
SELECT E.EMP_ID, E.FIRST_NAME,E.LAST_NAME,ED.DEPT_ID,ED.FROM_DATE,ED.TO_DATE
FROM EMPLOYEES E INNER JOIN EMPLOYEE_DEPT ED
ON E.EMP_ID = ED.EMP_ID
WHERE E.EMP_ID = 23; 

#INNER JOIN BOTH TABLE
DELETE EMPLOYEES,EMPLOYEE_DEPT
FROM EMPLOYEES INNER JOIN EMPLOYEE_DEPT 
ON EMPLOYEES.EMP_ID = EMPLOYEE_DEPT.EMP_ID
WHERE EMPLOYEES.EMP_ID=23;


#SELECT QUERY FOR FETCHING RECORDS
SELECT * FROM EMPLOYEES WHERE EMP_ID = 3;

SELECT * FROM EMPLOYEE_DEPT WHERE EMP_ID = 3 AND TO_DATE IS NOT NULL;

SELECT E.EMP_ID, E.FIRST_NAME,E.LAST_NAME,ED.DEPT_ID,ED.FROM_DATE,ED.TO_DATE
FROM EMPLOYEES E INNER JOIN EMPLOYEE_DEPT ED
ON E.EMP_ID = ED.EMP_ID
WHERE E.EMP_ID = 3 AND ED.TO_DATE IS NOT NULL;

#INNER JOIN, ONLY ONE TABLE
DELETE EMPLOYEE_DEPT
FROM EMPLOYEES INNER JOIN EMPLOYEE_DEPT 
ON EMPLOYEES.EMP_ID = EMPLOYEE_DEPT.EMP_ID
WHERE EMPLOYEES.EMP_ID=3 AND EMPLOYEE_DEPT.TO_DATE IS NOT NULL;

#LEFT OUTER JOIN
#SELECT QUERIES FOR FETCHING RECORDS
SELECT * FROM EMPLOYEES E
LEFT JOIN RATINGS R 
ON E.RATING = R.RATING_ID
WHERE R.RATING_ID=1;

SELECT * FROM EMPLOYEES WHERE RATING = 1;

SELECT * FROM RATINGS 
WHERE RATING_ID=1;

#DELETE QUERY- LEFT JOIN 
DELETE EMPLOYEES 
FROM EMPLOYEES LEFT JOIN RATINGS
ON EMPLOYEES.RATING = RATINGS.RATING_ID
WHERE RATINGS.RATING_ID=1;

#DELETE WITH A SUBQUERY –ERROR
DELETE FROM EMPLOYEES2 WHERE EMP_ID IN (SELECT EMP_ID FROM EMPLOYEES2 WHERE EMAIL IS NULL);

UPDATE EMPLOYEE_DEPT SET TO_DATE='3028-12-15' WHERE RECORD_ID=15;

#AUTO-INCREMENT COLUMNS ----DELETE AND THEN INSERT
#SELECT QUERY FOR FETCHING RECORDS 
SELECT MAX(LOCATION_ID) FROM DEPT_LOCATIONS;

#DELETE QUERY TO DELETE MAX LOCATION ID
DELETE FROM DEPT_LOCATIONS WHERE LOCATION_ID=9;

#INSERT A NEW RECORD WITH DEFAULT VALUE FOR LOCATION_ID WHICH IS AUTO-INCREMENTED.
INSERT INTO DEPT_LOCATIONS VALUES(DEFAULT,9,'MINAS TIRITH');

SELECT * FROM DEPT_LOCATIONS ORDER BY LOCATION_ID DESC;

#DELETE WITHOUT ANY WHERE CLAUSE.
SELECT COUNT(*) FROM EMPLOYEES2;

DELETE FROM EMPLOYEES2;


#ADDITIONAL QUERIES TO FIND AND MODIFY ALL THE FOREIGN KEYS TO INCLUDE ON DELETE CASCADE.
#TO FIND ALL THE FOREIGN KEY CONSTRAINTS
SELECT 
INFORMATION_SCHEMA.KEY_COLUMN_USAGE.REFERENCED_TABLE_NAME,
INFORMATION_SCHEMA.KEY_COLUMN_USAGE.REFERENCED_COLUMN_NAME,
INFORMATION_SCHEMA.KEY_COLUMN_USAGE.TABLE_NAME,
INFORMATION_SCHEMA.KEY_COLUMN_USAGE.COLUMN_NAME,
INFORMATION_SCHEMA.KEY_COLUMN_USAGE.CONSTRAINT_NAME
FROM INFORMATION_SCHEMA.KEY_COLUMN_USAGE
WHERE INFORMATION_SCHEMA.KEY_COLUMN_USAGE.REFERENCED_TABLE_NAME IS NOT NULL #FOR GETTING FOREIGN KEY CONSTRAINTS
AND INFORMATION_SCHEMA.KEY_COLUMN_USAGE.TABLE_SCHEMA = 'TESTDB'
ORDER BY INFORMATION_SCHEMA.KEY_COLUMN_USAGE.REFERENCED_TABLE_NAME;

# IF FOREIGN KEY CONSTRAINTS CASCADE ON DELETE OR NOT
SELECT DELETE_RULE,CONSTRAINT_NAME FROM INFORMATION_SCHEMA.REFERENTIAL_CONSTRAINTS 
WHERE CONSTRAINT_SCHEMA ='TESTDB'
AND CONSTRAINT_NAME='employee_dept_ibfk_1';

#Drop the existing foreign key constraints.
ALTER TABLE EMPLOYEE_DEPT
DROP  FOREIGN KEY EMPLOYEE_DEPT_IBFK_2;

ALTER TABLE EMPLOYEE_DEPT
DROP FOREIGN KEY EMPLOYEE_DEPT_IBFK_1;

#Add foreign key constraints with on delete cascade.
ALTER TABLE EMPLOYEE_DEPT
ADD FOREIGN KEY (EMP_ID) REFERENCES EMPLOYEES(EMP_ID) ON DELETE CASCADE;

ALTER TABLE EMPLOYEE_DEPT
ADD FOREIGN KEY (DEPT_ID) REFERENCES DEPARTMENTS(DEPT_ID) ON DELETE CASCADE;


 



